! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 23:52 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module RGEs_TSM 
 
Use Control 
Use Model_Data_TSM 
Use Mathematics 
 
Logical,Private,Save::OnlyDiagonal

Real(dp),Parameter::id3R(3,3)=& 
   & Reshape(Source=(/& 
   & 1,0,0,& 
 &0,1,0,& 
 &0,0,1& 
 &/),shape=(/3,3/)) 
Contains 


Subroutine GToParameters71(g,g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu)

Implicit None 
Real(dp), Intent(in) :: g(71) 
Real(dp),Intent(out) :: g1,g2,g3

Complex(dp),Intent(out) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'GToParameters71' 
 
g1= g(1) 
g2= g(2) 
g3= g(3) 
LT= Cmplx(g(4),g(5),dp) 
LT2= Cmplx(g(6),g(7),dp) 
LHT= Cmplx(g(8),g(9),dp) 
Lam= Cmplx(g(10),g(11),dp) 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yu(i1,i2) = Cmplx( g(SumI+12), g(SumI+13), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yd(i1,i2) = Cmplx( g(SumI+30), g(SumI+31), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Ye(i1,i2) = Cmplx( g(SumI+48), g(SumI+49), dp) 
End Do 
 End Do 
 
Kap= Cmplx(g(66),g(67),dp) 
MT= Cmplx(g(68),g(69),dp) 
Mu= Cmplx(g(70),g(71),dp) 
Do i1=1,71 
If (g(i1).ne.g(i1)) Then 
 Write(*,*) "NaN appearing in ",NameOfUnit(Iname) 
 Write(*,*) "At position ", i1 
 Call TerminateProgram 
End if 
End do 
Iname = Iname - 1 
 
End Subroutine GToParameters71

Subroutine ParametersToG71(g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu,g)

Implicit None 
Real(dp), Intent(out) :: g(71) 
Real(dp), Intent(in) :: g1,g2,g3

Complex(dp), Intent(in) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'ParametersToG71' 
 
g(1) = g1  
g(2) = g2  
g(3) = g3  
g(4) = Real(LT,dp)  
g(5) = Aimag(LT)  
g(6) = Real(LT2,dp)  
g(7) = Aimag(LT2)  
g(8) = Real(LHT,dp)  
g(9) = Aimag(LHT)  
g(10) = Real(Lam,dp)  
g(11) = Aimag(Lam)  
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+12) = Real(Yu(i1,i2), dp) 
g(SumI+13) = Aimag(Yu(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+30) = Real(Yd(i1,i2), dp) 
g(SumI+31) = Aimag(Yd(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+48) = Real(Ye(i1,i2), dp) 
g(SumI+49) = Aimag(Ye(i1,i2)) 
End Do 
End Do 

g(66) = Real(Kap,dp)  
g(67) = Aimag(Kap)  
g(68) = Real(MT,dp)  
g(69) = Aimag(MT)  
g(70) = Real(Mu,dp)  
g(71) = Aimag(Mu)  
Iname = Iname - 1 
 
End Subroutine ParametersToG71

Subroutine rge71(len, T, GY, F) 
Implicit None 
Integer, Intent(in) :: len 
Real(dp), Intent(in) :: T, GY(len) 
Real(dp), Intent(out) :: F(len) 
Integer :: i1,i2,i3,i4 
Integer :: j1,j2,j3,j4,j5,j6,j7 
Real(dp) :: q 
Real(dp) :: g1,betag11,betag12,Dg1,g2,betag21,betag22,Dg2,g3,betag31,betag32,Dg3
Complex(dp) :: LT,betaLT1,betaLT2,DLT,LT2,betaLT21,betaLT22,DLT2,LHT,betaLHT1,        & 
& betaLHT2,DLHT,Lam,betaLam1,betaLam2,DLam,Yu(3,3),betaYu1(3,3),betaYu2(3,3)             & 
& ,DYu(3,3),adjYu(3,3),Yd(3,3),betaYd1(3,3),betaYd2(3,3),DYd(3,3),adjYd(3,3)             & 
& ,Ye(3,3),betaYe1(3,3),betaYe2(3,3),DYe(3,3),adjYe(3,3),Kap,betaKap1,betaKap2,          & 
& DKap,MT,betaMT1,betaMT2,DMT,Mu,betaMu1,betaMu2,DMu
Iname = Iname +1 
NameOfUnit(Iname) = 'rge71' 
 
OnlyDiagonal = .Not.GenerationMixing 
q = t 
 
Call GToParameters71(gy,g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu)

Call Adjungate(Yu,adjYu)
Call Adjungate(Yd,adjYd)
Call Adjungate(Ye,adjYe)


If (TwoLoopRGE) Then 
End If 
 
 
!-------------------- 
! g1 
!-------------------- 
 
betag11  = 0

 
 
If (TwoLoopRGE) Then 
betag12 = 0

 
Dg1 = oo16pi2*( betag11 + oo16pi2 * betag12 ) 

 
Else 
Dg1 = oo16pi2* betag11 
End If 
 
 
!-------------------- 
! g2 
!-------------------- 
 
betag21  = 0

 
 
If (TwoLoopRGE) Then 
betag22 = 0

 
Dg2 = oo16pi2*( betag21 + oo16pi2 * betag22 ) 

 
Else 
Dg2 = oo16pi2* betag21 
End If 
 
 
!-------------------- 
! g3 
!-------------------- 
 
betag31  = 0

 
 
If (TwoLoopRGE) Then 
betag32 = 0

 
Dg3 = oo16pi2*( betag31 + oo16pi2 * betag32 ) 

 
Else 
Dg3 = oo16pi2* betag31 
End If 
 
 
!-------------------- 
! LT 
!-------------------- 
 
betaLT1  = 0

 
 
If (TwoLoopRGE) Then 
betaLT2 = 0

 
DLT = oo16pi2*( betaLT1 + oo16pi2 * betaLT2 ) 

 
Else 
DLT = oo16pi2* betaLT1 
End If 
 
 
Call Chop(DLT) 

!-------------------- 
! LT2 
!-------------------- 
 
betaLT21  = 0

 
 
If (TwoLoopRGE) Then 
betaLT22 = 0

 
DLT2 = oo16pi2*( betaLT21 + oo16pi2 * betaLT22 ) 

 
Else 
DLT2 = oo16pi2* betaLT21 
End If 
 
 
Call Chop(DLT2) 

!-------------------- 
! LHT 
!-------------------- 
 
betaLHT1  = 0

 
 
If (TwoLoopRGE) Then 
betaLHT2 = 0

 
DLHT = oo16pi2*( betaLHT1 + oo16pi2 * betaLHT2 ) 

 
Else 
DLHT = oo16pi2* betaLHT1 
End If 
 
 
Call Chop(DLHT) 

!-------------------- 
! Lam 
!-------------------- 
 
betaLam1  = 0

 
 
If (TwoLoopRGE) Then 
betaLam2 = 0

 
DLam = oo16pi2*( betaLam1 + oo16pi2 * betaLam2 ) 

 
Else 
DLam = oo16pi2* betaLam1 
End If 
 
 
Call Chop(DLam) 

!-------------------- 
! Yu 
!-------------------- 
 
betaYu1  = 0

 
 
If (TwoLoopRGE) Then 
betaYu2 = 0

 
DYu = oo16pi2*( betaYu1 + oo16pi2 * betaYu2 ) 

 
Else 
DYu = oo16pi2* betaYu1 
End If 
 
 
Call Chop(DYu) 

!-------------------- 
! Yd 
!-------------------- 
 
betaYd1  = 0

 
 
If (TwoLoopRGE) Then 
betaYd2 = 0

 
DYd = oo16pi2*( betaYd1 + oo16pi2 * betaYd2 ) 

 
Else 
DYd = oo16pi2* betaYd1 
End If 
 
 
Call Chop(DYd) 

!-------------------- 
! Ye 
!-------------------- 
 
betaYe1  = 0

 
 
If (TwoLoopRGE) Then 
betaYe2 = 0

 
DYe = oo16pi2*( betaYe1 + oo16pi2 * betaYe2 ) 

 
Else 
DYe = oo16pi2* betaYe1 
End If 
 
 
Call Chop(DYe) 

!-------------------- 
! Kap 
!-------------------- 
 
betaKap1  = 0

 
 
If (TwoLoopRGE) Then 
betaKap2 = 0

 
DKap = oo16pi2*( betaKap1 + oo16pi2 * betaKap2 ) 

 
Else 
DKap = oo16pi2* betaKap1 
End If 
 
 
Call Chop(DKap) 

!-------------------- 
! MT 
!-------------------- 
 
betaMT1  = 0

 
 
If (TwoLoopRGE) Then 
betaMT2 = 0

 
DMT = oo16pi2*( betaMT1 + oo16pi2 * betaMT2 ) 

 
Else 
DMT = oo16pi2* betaMT1 
End If 
 
 
Call Chop(DMT) 

!-------------------- 
! Mu 
!-------------------- 
 
betaMu1  = 0

 
 
If (TwoLoopRGE) Then 
betaMu2 = 0

 
DMu = oo16pi2*( betaMu1 + oo16pi2 * betaMu2 ) 

 
Else 
DMu = oo16pi2* betaMu1 
End If 
 
 
Call Chop(DMu) 

Call ParametersToG71(Dg1,Dg2,Dg3,DLT,DLT2,DLHT,DLam,DYu,DYd,DYe,DKap,DMT,DMu,f)

Iname = Iname - 1 
 
End Subroutine rge71  

Subroutine GToParameters73(g,g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu,v,vT)

Implicit None 
Real(dp), Intent(in) :: g(73) 
Real(dp),Intent(out) :: g1,g2,g3,v,vT

Complex(dp),Intent(out) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'GToParameters73' 
 
g1= g(1) 
g2= g(2) 
g3= g(3) 
LT= Cmplx(g(4),g(5),dp) 
LT2= Cmplx(g(6),g(7),dp) 
LHT= Cmplx(g(8),g(9),dp) 
Lam= Cmplx(g(10),g(11),dp) 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yu(i1,i2) = Cmplx( g(SumI+12), g(SumI+13), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Yd(i1,i2) = Cmplx( g(SumI+30), g(SumI+31), dp) 
End Do 
 End Do 
 
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
Ye(i1,i2) = Cmplx( g(SumI+48), g(SumI+49), dp) 
End Do 
 End Do 
 
Kap= Cmplx(g(66),g(67),dp) 
MT= Cmplx(g(68),g(69),dp) 
Mu= Cmplx(g(70),g(71),dp) 
v= g(72) 
vT= g(73) 
Do i1=1,73 
If (g(i1).ne.g(i1)) Then 
 Write(*,*) "NaN appearing in ",NameOfUnit(Iname) 
 Write(*,*) "At position ", i1 
 Call TerminateProgram 
End if 
End do 
Iname = Iname - 1 
 
End Subroutine GToParameters73

Subroutine ParametersToG73(g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu,v,vT,g)

Implicit None 
Real(dp), Intent(out) :: g(73) 
Real(dp), Intent(in) :: g1,g2,g3,v,vT

Complex(dp), Intent(in) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Integer i1, i2, i3, i4, SumI 
 
Iname = Iname +1 
NameOfUnit(Iname) = 'ParametersToG73' 
 
g(1) = g1  
g(2) = g2  
g(3) = g3  
g(4) = Real(LT,dp)  
g(5) = Aimag(LT)  
g(6) = Real(LT2,dp)  
g(7) = Aimag(LT2)  
g(8) = Real(LHT,dp)  
g(9) = Aimag(LHT)  
g(10) = Real(Lam,dp)  
g(11) = Aimag(Lam)  
Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+12) = Real(Yu(i1,i2), dp) 
g(SumI+13) = Aimag(Yu(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+30) = Real(Yd(i1,i2), dp) 
g(SumI+31) = Aimag(Yd(i1,i2)) 
End Do 
End Do 

Do i1 = 1,3
Do i2 = 1,3
SumI = (i2-1) + (i1-1)*3
SumI = SumI*2 
g(SumI+48) = Real(Ye(i1,i2), dp) 
g(SumI+49) = Aimag(Ye(i1,i2)) 
End Do 
End Do 

g(66) = Real(Kap,dp)  
g(67) = Aimag(Kap)  
g(68) = Real(MT,dp)  
g(69) = Aimag(MT)  
g(70) = Real(Mu,dp)  
g(71) = Aimag(Mu)  
g(72) = v  
g(73) = vT  
Iname = Iname - 1 
 
End Subroutine ParametersToG73

Subroutine rge73(len, T, GY, F) 
Implicit None 
Integer, Intent(in) :: len 
Real(dp), Intent(in) :: T, GY(len) 
Real(dp), Intent(out) :: F(len) 
Integer :: i1,i2,i3,i4 
Integer :: j1,j2,j3,j4,j5,j6,j7 
Real(dp) :: q 
Real(dp) :: g1,betag11,betag12,Dg1,g2,betag21,betag22,Dg2,g3,betag31,betag32,         & 
& Dg3,v,betav1,betav2,Dv,vT,betavT1,betavT2,DvT
Complex(dp) :: LT,betaLT1,betaLT2,DLT,LT2,betaLT21,betaLT22,DLT2,LHT,betaLHT1,        & 
& betaLHT2,DLHT,Lam,betaLam1,betaLam2,DLam,Yu(3,3),betaYu1(3,3),betaYu2(3,3)             & 
& ,DYu(3,3),adjYu(3,3),Yd(3,3),betaYd1(3,3),betaYd2(3,3),DYd(3,3),adjYd(3,3)             & 
& ,Ye(3,3),betaYe1(3,3),betaYe2(3,3),DYe(3,3),adjYe(3,3),Kap,betaKap1,betaKap2,          & 
& DKap,MT,betaMT1,betaMT2,DMT,Mu,betaMu1,betaMu2,DMu
Iname = Iname +1 
NameOfUnit(Iname) = 'rge73' 
 
OnlyDiagonal = .Not.GenerationMixing 
q = t 
 
Call GToParameters73(gy,g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu,v,vT)

Call Adjungate(Yu,adjYu)
Call Adjungate(Yd,adjYd)
Call Adjungate(Ye,adjYe)


If (TwoLoopRGE) Then 
End If 
 
 
!-------------------- 
! g1 
!-------------------- 
 
betag11  = 0

 
 
If (TwoLoopRGE) Then 
betag12 = 0

 
Dg1 = oo16pi2*( betag11 + oo16pi2 * betag12 ) 

 
Else 
Dg1 = oo16pi2* betag11 
End If 
 
 
!-------------------- 
! g2 
!-------------------- 
 
betag21  = 0

 
 
If (TwoLoopRGE) Then 
betag22 = 0

 
Dg2 = oo16pi2*( betag21 + oo16pi2 * betag22 ) 

 
Else 
Dg2 = oo16pi2* betag21 
End If 
 
 
!-------------------- 
! g3 
!-------------------- 
 
betag31  = 0

 
 
If (TwoLoopRGE) Then 
betag32 = 0

 
Dg3 = oo16pi2*( betag31 + oo16pi2 * betag32 ) 

 
Else 
Dg3 = oo16pi2* betag31 
End If 
 
 
!-------------------- 
! LT 
!-------------------- 
 
betaLT1  = 0

 
 
If (TwoLoopRGE) Then 
betaLT2 = 0

 
DLT = oo16pi2*( betaLT1 + oo16pi2 * betaLT2 ) 

 
Else 
DLT = oo16pi2* betaLT1 
End If 
 
 
Call Chop(DLT) 

!-------------------- 
! LT2 
!-------------------- 
 
betaLT21  = 0

 
 
If (TwoLoopRGE) Then 
betaLT22 = 0

 
DLT2 = oo16pi2*( betaLT21 + oo16pi2 * betaLT22 ) 

 
Else 
DLT2 = oo16pi2* betaLT21 
End If 
 
 
Call Chop(DLT2) 

!-------------------- 
! LHT 
!-------------------- 
 
betaLHT1  = 0

 
 
If (TwoLoopRGE) Then 
betaLHT2 = 0

 
DLHT = oo16pi2*( betaLHT1 + oo16pi2 * betaLHT2 ) 

 
Else 
DLHT = oo16pi2* betaLHT1 
End If 
 
 
Call Chop(DLHT) 

!-------------------- 
! Lam 
!-------------------- 
 
betaLam1  = 0

 
 
If (TwoLoopRGE) Then 
betaLam2 = 0

 
DLam = oo16pi2*( betaLam1 + oo16pi2 * betaLam2 ) 

 
Else 
DLam = oo16pi2* betaLam1 
End If 
 
 
Call Chop(DLam) 

!-------------------- 
! Yu 
!-------------------- 
 
betaYu1  = 0

 
 
If (TwoLoopRGE) Then 
betaYu2 = 0

 
DYu = oo16pi2*( betaYu1 + oo16pi2 * betaYu2 ) 

 
Else 
DYu = oo16pi2* betaYu1 
End If 
 
 
Call Chop(DYu) 

!-------------------- 
! Yd 
!-------------------- 
 
betaYd1  = 0

 
 
If (TwoLoopRGE) Then 
betaYd2 = 0

 
DYd = oo16pi2*( betaYd1 + oo16pi2 * betaYd2 ) 

 
Else 
DYd = oo16pi2* betaYd1 
End If 
 
 
Call Chop(DYd) 

!-------------------- 
! Ye 
!-------------------- 
 
betaYe1  = 0

 
 
If (TwoLoopRGE) Then 
betaYe2 = 0

 
DYe = oo16pi2*( betaYe1 + oo16pi2 * betaYe2 ) 

 
Else 
DYe = oo16pi2* betaYe1 
End If 
 
 
Call Chop(DYe) 

!-------------------- 
! Kap 
!-------------------- 
 
betaKap1  = 0

 
 
If (TwoLoopRGE) Then 
betaKap2 = 0

 
DKap = oo16pi2*( betaKap1 + oo16pi2 * betaKap2 ) 

 
Else 
DKap = oo16pi2* betaKap1 
End If 
 
 
Call Chop(DKap) 

!-------------------- 
! MT 
!-------------------- 
 
betaMT1  = 0

 
 
If (TwoLoopRGE) Then 
betaMT2 = 0

 
DMT = oo16pi2*( betaMT1 + oo16pi2 * betaMT2 ) 

 
Else 
DMT = oo16pi2* betaMT1 
End If 
 
 
Call Chop(DMT) 

!-------------------- 
! Mu 
!-------------------- 
 
betaMu1  = 0

 
 
If (TwoLoopRGE) Then 
betaMu2 = 0

 
DMu = oo16pi2*( betaMu1 + oo16pi2 * betaMu2 ) 

 
Else 
DMu = oo16pi2* betaMu1 
End If 
 
 
Call Chop(DMu) 

!-------------------- 
! v 
!-------------------- 
 
betav1  = 0

 
 
If (TwoLoopRGE) Then 
betav2 = 0

 
Dv = oo16pi2*( betav1 + oo16pi2 * betav2 ) 

 
Else 
Dv = oo16pi2* betav1 
End If 
 
 
!-------------------- 
! vT 
!-------------------- 
 
betavT1  = 0

 
 
If (TwoLoopRGE) Then 
betavT2 = 0

 
DvT = oo16pi2*( betavT1 + oo16pi2 * betavT2 ) 

 
Else 
DvT = oo16pi2* betavT1 
End If 
 
 
Call ParametersToG73(Dg1,Dg2,Dg3,DLT,DLT2,DLHT,DLam,DYu,DYd,DYe,DKap,DMT,             & 
& DMu,Dv,DvT,f)

Iname = Iname - 1 
 
End Subroutine rge73  

End Module RGEs_TSM 
 
