! -----------------------------------------------------------------------------  
! This file was automatically created by SARAH version 4.6.0 
! SARAH References: arXiv:0806.0538, 0909.2863, 1002.0840, 1207.0906, 1309.7223  
! (c) Florian Staub, 2013  
! ------------------------------------------------------------------------------  
! File created at 23:54 on 18.11.2015   
! ----------------------------------------------------------------------  
 
 
Module Tadpoles_TSM 
 
Use Model_Data_TSM 
Use SUSYMasses_TSM 
Use RGEs_TSM 
Use Control 

Use Mathematics 

Contains 


Subroutine SolveTadpoleEquations(g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,             & 
& Mu,v,vT,Tad1Loop)

Implicit None
Real(dp),Intent(inout) :: g1,g2,g3,v,vT

Complex(dp),Intent(inout) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Complex(dp), Intent(in) :: Tad1Loop(2)

! For numerical routines 
Real(dp) :: gC(73)
logical :: broycheck 
Real(dp) :: broyx(2)

If (HighScaleModel.Eq."LOW") Then 
Mu = (2*Lam*v**2 + 2*Kap*vT + LHT*vT**2 + (4*Tad1Loop(1))/v)/4._dp
MT = (Kap*v**2 + LHT*v**2*vT + LT*vT**3 - 4*LT2*vT**3 + 4*Tad1Loop(2))/(2._dp*vT)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(Mu,dp).ne.Real(Mu,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for Mu" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(Mu)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for Mu" 
   !Call TerminateProgram  
   Mu = Real(Mu,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(MT,dp).ne.Real(MT,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for MT" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(MT)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for MT" 
   !Call TerminateProgram  
   MT = Real(MT,dp) 
  SignOfMuChanged= .True. 
End If 
 Else 
Mu = (2*Lam*v**2 + 2*Kap*vT + LHT*vT**2 + (4*Tad1Loop(1))/v)/4._dp
MT = (Kap*v**2 + LHT*v**2*vT + LT*vT**3 - 4*LT2*vT**3 + 4*Tad1Loop(2))/(2._dp*vT)

 ! ----------- Check solutions for consistency  -------- 

 ! Check for NaNs 
If (Real(Mu,dp).ne.Real(Mu,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for Mu" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(Mu)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for Mu" 
   !Call TerminateProgram  
   Mu = Real(Mu,dp) 
  SignOfMuChanged= .True. 
End If 
 If (Real(MT,dp).ne.Real(MT,dp)) Then 
   Write(*,*) "NaN appearing in solution of tadpole equations for MT" 
   Call TerminateProgram  
 End If 
 If (Abs(AImag(MT)).gt.1.0E-04_dp) Then 
   Write(*,*) "No real solution of tadpole equations for MT" 
   !Call TerminateProgram  
   MT = Real(MT,dp) 
  SignOfMuChanged= .True. 
End If 
 End if 
End Subroutine SolveTadpoleEquations

Subroutine CalculateTadpoles(g1,g2,g3,LT,LT2,LHT,Lam,Yu,Yd,Ye,Kap,MT,Mu,              & 
& v,vT,Tad1Loop,TadpoleValues)

Real(dp),Intent(in) :: g1,g2,g3,v,vT

Complex(dp),Intent(in) :: LT,LT2,LHT,Lam,Yu(3,3),Yd(3,3),Ye(3,3),Kap,MT,Mu

Complex(dp), Intent(in) :: Tad1Loop(2)

Real(dp), Intent(out) :: TadpoleValues(2)

TadpoleValues(1) = Real(-(v*(-4._dp*(Mu) + 2*Lam*v**2 + 2*Kap*vT + LHT*vT**2))        & 
& /4._dp - Tad1Loop(1),dp) 
TadpoleValues(2) = Real((2*MT*vT - (LT - 4._dp*(LT2))*vT**3 - v**2*(Kap + LHT*vT))    & 
& /4._dp - Tad1Loop(2),dp) 
End Subroutine CalculateTadpoles 

End Module Tadpoles_TSM 
 
